<?php
/**
 * 
 * Community Builder - run user sync module
 * CB code taken from 1.1 release
 * 
 * Part of cb/vm integration plugin
 *  Ben Jones / e-motion design
 * 
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mosConfig_absolute_path , $database, $my;
$my->usertype="Super Administrator";
require_once( $mosConfig_absolute_path . '/administrator/components/com_comprofiler/library/cb/cb.database.php' );
require_once( $mosConfig_absolute_path . '/administrator/components/com_comprofiler/plugin.class.php' );
require_once( $mosConfig_absolute_path . '/administrator/components/com_comprofiler/comprofiler.class.php' );

ob_start();
syncUsers();
ob_end_clean();

function syncUsers() {
    global $_CB_database, $my, $ueConfig;

    // 1. add missing comprofiler entries, guessing naming depending on CB's name style:
	switch ( $ueConfig['name_style'] ) {
		case 2:
			// firstname + lastname:
 			$sql = "INSERT IGNORE INTO #__comprofiler(id,user_id,lastname,firstname) "
 				  ." SELECT id,id, SUBSTRING_INDEX(name,' ',-1), "
 								 ."SUBSTRING( name, 1, length( name ) - length( SUBSTRING_INDEX( name, ' ', -1 ) ) -1 ) "
 				  ." FROM #__users";    		
		break;
		case 3:
			// firstname + middlename + lastname:
			$sql = "INSERT IGNORE INTO #__comprofiler(id,user_id,middlename,lastname,firstname) "
				 . " SELECT id,id,SUBSTRING( name, INSTR( name, ' ' ) +1,"
				 						  ." length( name ) - INSTR( name, ' ' ) - length( SUBSTRING_INDEX( name, ' ', -1 ) ) -1 ),"
				 		 ." SUBSTRING_INDEX(name,' ',-1),"
				 		 ." IF(INSTR(name,' '),SUBSTRING_INDEX( name, ' ', 1 ),'') "
				 . " FROM #__users";
    		break;
    	default:
 			// name only:
			$sql = "INSERT IGNORE INTO #__comprofiler(id,user_id) SELECT id,id FROM #__users";
   			break;
    }
	$_CB_database->setQuery($sql);
	if (!$_CB_database->query()) {
		print("<font color=red>SQL error" . $_CB_database->stderr(true)."</font><br />");
		return;
	}
	$affected = mysql_affected_rows();
	if ($affected) {
		print "<p><font color='orange'>Added ".$affected." new entries to Community Builder from users Table.</font></p>";
	}

	$sql = "UPDATE #__comprofiler SET `user_id`=`id`";
	$_CB_database->setQuery($sql);
	if (!$_CB_database->query()) {
		print("<font color=red>SQL error" . $_CB_database->stderr(true)."</font><br />");
		return;
	}
	$affected = mysql_affected_rows();
	if ($affected) {
		print "<p><font color='orange'>Fixed ".$affected." existing entries in Community Builder: fixed wrong user_id.</font></p>";
	}

	// 2. remove excessive comprofiler entries (e.g. if admin used mambo/joomla delete user function:
	$sql = "SELECT c.id FROM #__comprofiler c LEFT JOIN #__users u ON u.id = c.id WHERE u.id IS NULL";
	$_CB_database->setQuery($sql);
	$users = $_CB_database->loadResultArray();
	if (count($users)) {
		print "<p><font color='orange'>Removing ".count($users)." entries from Community Builder missing in users Table.</font></p>";
	}
	if ($_CB_database->getErrorNum()) {
		print("<font color=red>SQL error" . $_CB_database->stderr(true)."</font><br />");
		return;
	}
	$msg = deleteUsers($users, true);
	print "<p>".$msg."</p>";
	print "<font color=green>Joomla/Mambo User Table and Joomla/Mambo Community Builder User Table now in sync!</font>";
}

function deleteUsers( $cid, $inComprofilerOnly = false ) {
	global $_CB_database, $acl,$_PLUGINS, $ueConfig, $my;
	
	$msg = checkCBpermissions( $cid, "delete" );
	
	if (!$msg && is_array( $cid ) && count( $cid )) {
		$obj = new mosUser( $_CB_database );
		$obj2 = new moscomprofiler( $_CB_database );
		$tabs = new cbTabs( 0, 2);
		foreach ($cid as $id) {
			$obj->load( (int) $id );
			// check for a super admin ... can't delete them
/* done above
			$groups = $acl->get_object_groups( 'users', $id, 'ARO' );
			$this_group = strtolower( $acl->get_group_name( $groups[0], 'ARO' ) );
			if ( $this_group == 'super administrator' && $my--->gid != 25 ) {
				$msg .= "You cannot delete a Super Administrator";
 			} else if ( $id == $my->id ){
 				$msg .= "You cannot delete Yourself!";
 			} else if ( ( $this_group == 'administrator' ) && ( $my--->gid == 24 ) ){
 				$msg .= "You cannot delete another `Administrator` only `Super Administrators` have this power";
			} else if (($obj->gid == $my--->gid && $my--->gid != 25) || !in_array($obj->gid,getChildGIDS($my--->gid))) {
				$msg .= "You cannot delete a `".$this_group."`. Only higher-level users have this power";
			} else
*/			{
				$count = 2;
				if ( $obj->gid == 25 ) {
					// count number of active super admins
					$query = "SELECT COUNT( id )"
					. "\n FROM #__users"
					. "\n WHERE gid = 25"
					. "\n AND block = 0"
					;
					$_CB_database->setQuery( $query );
					$count = $_CB_database->loadResult();
				}
				
				if ( $count <= 1 && $obj->gid == 25 ) {
				// cannot delete Super Admin where it is the only one that exists
					$msg .= "You cannot delete this Super Administrator as it is the only active Super Administrator for your site";
				} else {
					// delete user
					$result = cbDeleteUser( $id, null, $inComprofilerOnly );
					if ( $result === null ) {
						$msg .= "User not found";
					} elseif (is_string( $result ) && ( $result != "" ) ) {
						$msg .= $result;
					}
				}
			}
		}
	}
	return $msg;
}

?>